// This file is generated by kconfig_compiler_kf6 from workspaceoptions_kdeglobalssettings.kcfg.
// All changes you do to this file will be lost.
#ifndef WORKSPACEOPTIONSGLOBALSSETTINGS_H
#define WORKSPACEOPTIONSGLOBALSSETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class WorkspaceOptionsGlobalsSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    WorkspaceOptionsGlobalsSettings( QObject *parent = nullptr );
    ~WorkspaceOptionsGlobalsSettings() override;

    /**
      Set Single click to open files
    */
    void setSingleClick( bool v )
    {
      if (v != mSingleClick && !isSingleClickImmutable()) {
        mSingleClick = v;
        Q_EMIT singleClickChanged();
      }
    }

    Q_PROPERTY(bool singleClick READ singleClick WRITE setSingleClick NOTIFY singleClickChanged)
    Q_PROPERTY(bool isSingleClickImmutable READ isSingleClickImmutable CONSTANT)
    /**
      Get Single click to open files
    */
    bool singleClick() const
    {
      return mSingleClick;
    }

    /**
      Is Single click to open files Immutable
    */
    bool isSingleClickImmutable() const
    {
      return isImmutable( QStringLiteral( "singleClick" ) );
    }

    /**
      Get Single click to open files default value
    */
    bool defaultSingleClickValue() const
    {
        return defaultSingleClickValue_helper();
    }

    /**
      Set Animation speed
    */
    void setAnimationDurationFactor( double v )
    {
      if (v != mAnimationDurationFactor && !isAnimationDurationFactorImmutable()) {
        mAnimationDurationFactor = v;
        Q_EMIT animationDurationFactorChanged();
      }
    }

    Q_PROPERTY(double animationDurationFactor READ animationDurationFactor WRITE setAnimationDurationFactor NOTIFY animationDurationFactorChanged)
    Q_PROPERTY(bool isAnimationDurationFactorImmutable READ isAnimationDurationFactorImmutable CONSTANT)
    /**
      Get Animation speed
    */
    double animationDurationFactor() const
    {
      return mAnimationDurationFactor;
    }

    /**
      Is Animation speed Immutable
    */
    bool isAnimationDurationFactorImmutable() const
    {
      return isImmutable( QStringLiteral( "animationDurationFactor" ) );
    }

    /**
      Get Animation speed default value
    */
    double defaultAnimationDurationFactorValue() const
    {
        return defaultAnimationDurationFactorValue_helper();
    }

    /**
      Set Smooth scrolling
    */
    void setSmoothScroll( bool v )
    {
      if (v != mSmoothScroll && !isSmoothScrollImmutable()) {
        mSmoothScroll = v;
        Q_EMIT smoothScrollChanged();
      }
    }

    Q_PROPERTY(bool smoothScroll READ smoothScroll WRITE setSmoothScroll NOTIFY smoothScrollChanged)
    Q_PROPERTY(bool isSmoothScrollImmutable READ isSmoothScrollImmutable CONSTANT)
    /**
      Get Smooth scrolling
    */
    bool smoothScroll() const
    {
      return mSmoothScroll;
    }

    /**
      Is Smooth scrolling Immutable
    */
    bool isSmoothScrollImmutable() const
    {
      return isImmutable( QStringLiteral( "smoothScroll" ) );
    }

    /**
      Get Smooth scrolling default value
    */
    bool defaultSmoothScrollValue() const
    {
        return defaultSmoothScrollValue_helper();
    }

    /**
      Set Left-click in scrollbar track moves scrollbar by one page
    */
    void setScrollbarLeftClickNavigatesByPage( bool v )
    {
      if (v != mScrollbarLeftClickNavigatesByPage && !isScrollbarLeftClickNavigatesByPageImmutable()) {
        mScrollbarLeftClickNavigatesByPage = v;
        Q_EMIT scrollbarLeftClickNavigatesByPageChanged();
      }
    }

    Q_PROPERTY(bool scrollbarLeftClickNavigatesByPage READ scrollbarLeftClickNavigatesByPage WRITE setScrollbarLeftClickNavigatesByPage NOTIFY scrollbarLeftClickNavigatesByPageChanged)
    Q_PROPERTY(bool isScrollbarLeftClickNavigatesByPageImmutable READ isScrollbarLeftClickNavigatesByPageImmutable CONSTANT)
    /**
      Get Left-click in scrollbar track moves scrollbar by one page
    */
    bool scrollbarLeftClickNavigatesByPage() const
    {
      return mScrollbarLeftClickNavigatesByPage;
    }

    /**
      Is Left-click in scrollbar track moves scrollbar by one page Immutable
    */
    bool isScrollbarLeftClickNavigatesByPageImmutable() const
    {
      return isImmutable( QStringLiteral( "scrollbarLeftClickNavigatesByPage" ) );
    }

    /**
      Get Left-click in scrollbar track moves scrollbar by one page default value
    */
    bool defaultScrollbarLeftClickNavigatesByPageValue() const
    {
        return defaultScrollbarLeftClickNavigatesByPageValue_helper();
    }

    /**
      Set Double click interval
    */
    void setDoubleClickInterval( int v )
    {
      if (v < 100)
      {
        qDebug() << "setDoubleClickInterval: value " << v << " is less than the minimum value of 100";
        v = 100;
      }

      if (v > 2000)
      {
        qDebug() << "setDoubleClickInterval: value " << v << " is greater than the maximum value of 2000";
        v = 2000;
      }

      if (v != mDoubleClickInterval && !isDoubleClickIntervalImmutable()) {
        mDoubleClickInterval = v;
        Q_EMIT doubleClickIntervalChanged();
      }
    }

    Q_PROPERTY(int doubleClickInterval READ doubleClickInterval WRITE setDoubleClickInterval NOTIFY doubleClickIntervalChanged)
    Q_PROPERTY(bool isDoubleClickIntervalImmutable READ isDoubleClickIntervalImmutable CONSTANT)
    /**
      Get Double click interval
    */
    int doubleClickInterval() const
    {
      return mDoubleClickInterval;
    }

    /**
      Is Double click interval Immutable
    */
    bool isDoubleClickIntervalImmutable() const
    {
      return isImmutable( QStringLiteral( "doubleClickInterval" ) );
    }

    /**
      Get Double click interval default value
    */
    int defaultDoubleClickIntervalValue() const
    {
        return defaultDoubleClickIntervalValue_helper();
    }


    enum {
      signalSingleClickChanged = 1,
      signalAnimationDurationFactorChanged = 2,
      signalSmoothScrollChanged = 3,
      signalScrollbarLeftClickNavigatesByPageChanged = 4,
      signalDoubleClickIntervalChanged = 5
    };

  Q_SIGNALS:
    void singleClickChanged();

    void animationDurationFactorChanged();

    void smoothScrollChanged();

    void scrollbarLeftClickNavigatesByPageChanged();

    void doubleClickIntervalChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // KDE
    bool mSingleClick;
    bool defaultSingleClickValue_helper() const;
    double mAnimationDurationFactor;
    double defaultAnimationDurationFactorValue_helper() const;
    bool mSmoothScroll;
    bool defaultSmoothScrollValue_helper() const;
    bool mScrollbarLeftClickNavigatesByPage;
    bool defaultScrollbarLeftClickNavigatesByPageValue_helper() const;
    int mDoubleClickInterval;
    int defaultDoubleClickIntervalValue_helper() const;

  private:
};

#endif

